import java.io.*;
import java.net.*;
import java.util.*;

public class SampleMatchMakerClient {
  public static void main(String[] args) throws Exception {
    Socket socket = null;
    PrintWriter out = null;
    BufferedReader in = null;
    try {
      socket = new Socket("localhost", 20001);
      out = new PrintWriter(socket.getOutputStream(), true);
      in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
    } 
    catch (UnknownHostException e) {
      System.out.println("Unknown host");
      System.exit(-1);
    } 
    catch (IOException e) {
      System.out.println("No I/O");
      System.exit(-1);
    }
    out.println("Matchmaker");    
    String inputLine = in.readLine();
    System.out.println("Server says: " + inputLine);
    int N = inputLine.split(":").length - 1;
    if(N < 2 || N > 200) {
      System.out.println("invalid N");
      System.exit(-1);
    }
    for (int i = 1; i < 40; i++) {
      inputLine = in.readLine();
      System.out.println("Server says: " + inputLine);
      if(i > 18) {
        Random generator = new Random();
        Thread.sleep(200);
        String candidate = "";
        for(int k = 0; k < N; k++) {
          if (k>0)
            candidate = candidate + ":";
          candidate = candidate + "0." + (Integer.toString(
            (int)(generator.nextDouble() * 10000)));
        }
        out.println(candidate);
      }
    }
    inputLine = in.readLine();
    System.out.println("Server says: " + inputLine);    
    out.close();
    in.close();
    socket.close();
  }
}