import java.util.HashMap;
import java.util.ArrayList;

public class Standings{
	HashMap<String,TeamResult> results;


	public Standings() {
		results = new HashMap<String,TeamResult>();	}

	public void addTeam(TeamResult teamData) {
		results.put(teamData.teamName, teamData);
	}

	private ArrayList<String> getSortedKeys() {
		ArrayList<String> sortKeys = new ArrayList<String>();
		ArrayList<String> failKeys = new ArrayList<String>();

		for (TeamResult teamData : results.values()) {
			if ((teamData.visitAll&&teamData.underTime) == false) {
				failKeys.add(teamData.teamName);
			}
			else {
				boolean lookingForPlace = true;
				if (sortKeys.size()==0) {
					lookingForPlace = false;
				}
				int arrayIndex = 0;
				while (lookingForPlace) {
					double tempScore = results.get(sortKeys.get(arrayIndex)).distScore;
					if (teamData.distScore < tempScore) {
						lookingForPlace = false;
					}
					else {
						arrayIndex++;
						if (arrayIndex >= sortKeys.size()) {
							lookingForPlace = false;
						}
					}
				}
				if (arrayIndex<=sortKeys.size())
					sortKeys.add(arrayIndex,teamData.teamName);
				else
					sortKeys.add(teamData.teamName);
			}
			
		}

		sortKeys.addAll(failKeys);
		return sortKeys;
	}

	private String humanTime(long millis) {
		int mins = (int) millis / 60000;
		int secs = (int) (millis % 60000)/1000;
		return String.format("%dMins %dSecs", mins, secs);
	}

	private String failInfo(TeamResult result) {
		String output = "";
		if (!result.visitAll) {
			if (!result.underTime) {
				output = "FAIL - TIME/CITY";
			}
			else {
				output = "FAIL - CITY";
			}
		}
		else {
			if (!result.underTime) {
				output = "FAIL - TIME";
			}
		}
		return output;
	}

	public void printOutStandings() {
		ArrayList<String> sortedKeys = getSortedKeys();
		System.out.print("************************************************************\n");
		System.out.print("                            STANDINGS                       \n");
		System.out.print("************************************************************\n");
		for (String name : sortedKeys) {
			System.out.format("%.10s %,20f   %s    %s\n",
				results.get(name).teamName,
				results.get(name).distScore,
				humanTime(results.get(name).timeScore),
				failInfo(results.get(name)));
		}
	}
}

class TeamResult{
	public String teamName;
	public double distScore;
	public long timeScore;
	public boolean visitAll;
	public boolean underTime;

	public TeamResult(String name, double dist, long time, boolean visit, boolean limit) {
		this.teamName = name;
		this.distScore = dist;
		this.timeScore = time;
		this.visitAll = visit;
		this.underTime = limit;
	}
}