package snow;

import java.beans.*;

import javax.swing.*;

public class SWQuickHelpDialog
  extends JDialog implements PropertyChangeListener
{
  JOptionPane optionPane;
  
  SWQuickHelpDialog(JFrame _parent)
  {
    super(_parent);
    setTitle("Quick Help");
    optionPane =
      new JOptionPane(
        getQuickHelpMessage(),
        JOptionPane.PLAIN_MESSAGE,
        JOptionPane.DEFAULT_OPTION);
    setContentPane(optionPane);
    optionPane.addPropertyChangeListener(this);
    pack();
  }

  String getQuickHelpMessage()
  {
    String[] ss =
      {
        "Use the arrow keys to move the plow around.",
        "Hit Enter to toggle plowing on/off.",
        "Click on a block to inspect it.",
      };
    StringBuilder sb = new StringBuilder();
    for (String s : ss)
    {
      sb.append(s + "\n");
    }
    return sb.toString();
  }
  
  public void propertyChange(PropertyChangeEvent evt)
  {
    Object value = optionPane.getValue();
    if (value == JOptionPane.UNINITIALIZED_VALUE)
    {
      //ignore reset
      return;
    }
    optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);
    setVisible(false);
  }
}
